Bug 7928 - Autogenerate UIEvent, MouseEvent and KeyboardEvent
Summary: Autogenerate UIEvent, MouseEvent and KeyboardEvent
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit Misc. (show other bugs)
Version: 420+
Hardware: Macintosh OS X 10.4
: P4 Normal
Assignee: Eric Seidel (no email)
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2006-03-23 03:08 PST by Eric Seidel (no email)
Modified: 2006-04-14 18:00 PDT (History)
0 users

See Also:


Attachments
Incomplete first attempt at autogenerating UIEvent, MouseEvent & KeyboardEvent (48.94 KB, patch)
2006-03-23 03:18 PST, Eric Seidel (no email)
darin: review-
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Eric Seidel (no email) 2006-03-23 03:08:15 PST
Autogenerate UIEvent, MouseEvent and KeyboardEvent

I decided it was time to get my hands dirty with the autogenerated bindings...
Comment 1 Eric Seidel (no email) 2006-03-23 03:18:48 PST
Created attachment 7248 [details]
Incomplete first attempt at autogenerating UIEvent, MouseEvent & KeyboardEvent

I'm marking this patch for review even though I know it is incomplete.  Currently it doesn't properly handle marking of the clipboard object on MouseEvent when MouseEvent is marked.  There are probably other things it doesn't quite do right too. I'm posting this for review now so that we can hash out the details all having looked at the same patch.

I also think that this code will need at least one test case which tries to dispatch to a DocType node or something else which is a node but not an EventTarget.
Comment 2 Darin Adler 2006-03-23 07:19:07 PST
Anders said he had already completed the event classes, so you might want to talk to him about it.

In cases like mouse event where you have something custom to do, you need to create a base class that is hand-written to go along with the autogenerated code.
Comment 3 Darin Adler 2006-03-24 08:24:01 PST
Comment on attachment 7248 [details]
Incomplete first attempt at autogenerating UIEvent, MouseEvent & KeyboardEvent

Either we have to mark the clipboard or prove that we don't need to mark it -- I'd like to see a test that explores this.

Patch otherwise looks fine to me.
Comment 4 Eric Seidel (no email) 2006-03-28 14:57:50 PST
(In reply to comment #3)
> (From update of attachment 7248 [details] [edit])
> Either we have to mark the clipboard or prove that we don't need to mark it --
> I'd like to see a test that explores this.

I'm not even sure what clipboard is used for.  It looks like it's used during Dragging and Clipboard events, but only seems to be marked when dragging.  I've moved that code down onto DOMEvent, as that is where the clipboard pointer was being stored anyway.

> Patch otherwise looks fine to me.
> 

Comment 5 Eric Seidel (no email) 2006-04-14 18:00:28 PDT
This has been since fixed and landed.